(function() {
    'use strict';

    mui.init({
        pullRefresh: {
            container: '#fp-pull-refresh',
            down: {
                contentdown: '下拉可以刷新',
                contentover: '释放立即刷新',
                contentrefresh: '正在加载...',
                callback: pulldownRefresh
            },
            up: {
                contentrefresh: '正在加载...',
                contentnomore: '没有更多数据了',
                callback: pullupRefresh
            }
        }
    });

    if (mui.os.plus) {
        mui.plusReady(function() {
            setTimeout(function() {
                mui('#fp-pull-refresh').pullRefresh().pullupLoading();
            }, 500);
        });
    } else {
        mui.ready(function() {
            mui('#fp-pull-refresh').pullRefresh().pullupLoading();
        });
    }

    function scrollToTop() {
        if (mui) {
            if (mui.os.ios) {
                mui('#fp-pull-refresh').pullRefresh().scrollTo(0, 0, 100);
            } else if (mui.os.android) {
                mui.scrollTo(0, 100);
            }
        }
    }

    window.addEventListener('refreshKeyList', pullupRefresh, false);
    window.addEventListener('clearKeyList', clearAllKeys, false);
    window.addEventListener('scrollToListTop', scrollToTop, false);

//  mui.ready(function() {
//
//  });

    mui.plusReady(function() {
//      var keys = [];
//      for (var i = 0; i < 299; i++) {
//          keys.push(i);
//      }
//      fpSettings.putKeys(keys);
    });

    var maxKeyShow = 37;

    function pulldownRefresh() {
        if (!document || !plus || !fpSettings) {
            return;
        }

        var table = document.body.querySelector('.mui-table-view');
        if (!table) {
            return;
        }

        var nodes = table.children;
        if (!nodes) {
            return;
        }

        var nodeCount = nodes.length;

        var keys = fpSettings.getKeys();
        if (!keys) {
            return;
        }

        var keyCount = keys.length;

        if (nodeCount > 0) {
            if (nodeCount > keyCount) {
                for (var j = keyCount; j < nodeCount; j++) {
                    table.removeChild(nodes[0]);
                }
                nodeCount = nodes.length;
            }
            if (nodeCount < 25) {
                mui('#fp-pull-refresh').pullRefresh().pullupLoading();
            } else {
                for (var i = 0; (i < nodeCount) && (i < keyCount); i++) {
                    nodes[i].children[1].textContent = keys[i];
                }
            }
        } else {
            if (keyCount > 0) {
                mui('#fp-pull-refresh').pullRefresh().pullupLoading();
            }
        }

        mui('#fp-pull-refresh').pullRefresh().endPulldownToRefresh();
    }

    function pullupRefresh() {
        if (!document || !plus || !fpSettings) {
            return;
        }

        var table = document.body.querySelector('.mui-table-view');
        if (!table) {
            return;
        }

        var cells = table.children;
        if (!cells) {
            return;
        }

        var cellCount = cells.length;

        var keys = fpSettings.getKeys();
        if (!keys) {
            return;
        }

        var keyCount = keys.length;

        if (cellCount >= keyCount) {
            mui('#fp-pull-refresh').pullRefresh().endPullupToRefresh(true);
        } else {
            var len = cellCount + maxKeyShow;

            if (len > keyCount) {
                len = keyCount;
            }

            var arrLi = [];
            for (var i = cellCount; i < len; i++) {
                var btnEditHtml = '<div class="mui-slider-left mui-disabled"><a class="mui-btn fp-btn-blue">编辑</a></div>';
                var btnDelHtml = '<div class="mui-slider-right mui-disabled"><a class="mui-btn mui-btn-red">删除</a></div>';
                var liHtml = btnEditHtml + '<div class="mui-slider-handle">' + keys[i] + '</div>' + btnDelHtml;
                arrLi.push(liHtml);
            }
            var listHtml = '<li class="mui-table-view-cell">' + arrLi.join('</li><li class="mui-table-view-cell">') + '</li>';
            table.innerHTML += listHtml;

//          for (var i = cellCount; i < len; i++) {
//              var li = document.createElement('li');
//              var btnEditHtml = '<div class="mui-slider-left mui-disabled"><a class="mui-btn fp-btn-blue">编辑</a></div>';
//              var btnDelHtml = '<div class="mui-slider-right mui-disabled"><a class="mui-btn mui-btn-red">删除</a></div>';
//
//              li.className = 'mui-table-view-cell';
//              li.innerHTML = btnEditHtml + '<div class="mui-slider-handle">' + keys[i] + '</div>' + btnDelHtml;
//              table.appendChild(li);
//          }

            if (table.children.length >= keyCount) {
                mui('#fp-pull-refresh').pullRefresh().endPullupToRefresh(true);
            } else {
                mui('#fp-pull-refresh').pullRefresh().endPullupToRefresh(false);
            }
        }
    }

    function replaceKey(oldKey, newKey) {
        if (!plus || !fpSettings || !oldKey || newKey === null) {
            return;
        }

        var keys = fpSettings.getKeys();

        if (oldKey.length < 1) {
            return -1;
        }

        var oldKeyIndex = keys.indexOf(oldKey);

        if (oldKeyIndex === -1) {
            return -1;
        }

        var hasRemove = false;

        if (newKey.length > 0) {
            var newKeyIndex = keys.indexOf(newKey);

            if (newKeyIndex === -1) {
                keys.splice(oldKeyIndex, 1, newKey);
            } else {
                keys.splice(oldKeyIndex, 1);
                hasRemove = true;
            }
        } else {
            keys.splice(oldKeyIndex, 1);
            hasRemove = true;
        }

        fpSettings.putKeys(keys);

        return hasRemove;
    }

    function removeMoreKeys() {
        if (!document) {
            return;
        }

        var table = document.body.querySelector('.mui-table-view');
        if (!table) {
            return;
        }

        var nodes = table.children;
        if (!nodes) {
            return;
        }

        var nodeCount = nodes.length;

        if (nodeCount > maxKeyShow) {
            for (var i = maxKeyShow; i < nodeCount; i++) {
                table.removeChild(nodes[maxKeyShow]);
            }
        }
    }

    function removeAllKeys() {
        if (!document) {
            return;
        }

        var table = document.body.querySelector('.mui-table-view');
        if (!table) {
            return;
        }

        var nodes = table.children;
        if (!nodes) {
            return;
        }

        var nodeCount = nodes.length;

        if (nodeCount > 0) {
            for (var i = 0; i < nodeCount; i++) {
                table.removeChild(nodes[0]);
            }
        }
    }

    function clearAllKeys() {
        if (!document) {
            return;
        }

        var table = document.body.querySelector('.mui-table-view');
        if (!table) {
            return;
        }

        table.innerHTML = '';
    }

    //  mui('#fp-key-list').on('tap', '.mui-btn.mui-btn-red', function(event) {
    //      var self = this;
    //      var key = self.parentNode.parentNode.children[1].textContent;
    //      mui.confirm('确认删除区分代号：' + key + ' ？', '花密', ['确定', '取消'], function(e) {
    //          if (e.index === 0) {
    //              var li = self.parentNode.parentNode;
    //              replaceKey(key, '');
    //              li.parentNode.removeChild(li);
    //          }
    //      });
    //  });

    mui('#fp-key-list').on('slideleft', '.mui-table-view-cell', function(event) {
        var self = this;
        var key = self.children[1].textContent;
        mui.confirm('确认删除区分代号：' + key + ' ？', '花密', ['确定', '取消'], function(e) {
            if (e.index === 0) {
                replaceKey(key, '');
                self.parentNode.removeChild(self);
            } else {
                mui.swipeoutClose(self);
            }
        });
    });

    mui('#fp-key-list').on('slideright', '.mui-table-view-cell', function(event) {
        if (!plus) {
            return;
        }

        var self = this;
        var key = self.children[1].textContent;

        plus.nativeUI.prompt('将 ' + key + ' 修改为：', function(event) {
            if (event.index === 0) {
                var newKey = event.value;
                if (newKey && (newKey.length > 0)) {
                    if (replaceKey(key, newKey) === false) {
                        self.children[1].textContent = newKey;
                    } else if (replaceKey(key, newKey) === true) {
                        self.parentNode.removeChild(self);
                    }
                }
            }
            mui.swipeoutClose(self);
        }, '花密', '请输入新的区分代号', ['确定', '取消']);
    });

}());
