(function() {
    'use strict';

    //启用双击监听
    mui.init({
        gestureConfig: {
            doubletap: true
        },
        subpages: [{
            url: 'key-sub.html',
            id: 'key-sub',
            styles: {
                top: '45px',
                bottom: '0'
            }
        }],
        beforeback: function(){
            if (plus) {
                var setting = plus.webview.getWebviewById('setting');
                if (setting) {
                    mui.fire(setting, 'refreshKeyCount', {});
                }
            }
            return true;
        }
    });

    mui.plusReady(function() {
        // 隐藏滚动条
        plus.webview.currentWebview().setStyle({
            scrollIndicator: 'none'
        });

        document.querySelector('header').addEventListener('doubletap', function () {
            var keySub = plus.webview.getWebviewById('key-sub');
            if (keySub) {
                mui.fire(keySub, 'scrollToListTop', {});
            }
        }, false);
    });

    // 导出按钮点击事件
    document.getElementById('fp-export').addEventListener('tap', function(event) {
        if (plus && fpSettings) {
            var keys = fpSettings.getKeysStr();

            try {
                if (mui.os.android) {
                    var context = plus.android.importClass('android.content.Context');
                    var main = plus.android.runtimeMainActivity();
                    var clip = main.getSystemService(context.CLIPBOARD_SERVICE);

                    plus.android.invoke(clip, 'setText', keys);

                } else if (mui.os.ios) {
                    var UIPasteboard = plus.ios.importClass('UIPasteboard');
                    var generalPasteboard = UIPasteboard.generalPasteboard();
                    // generalPasteboard.setValueforPasteboardType(keys, 'public.utf8-plain-text');
                    generalPasteboard.plusCallMethod({
                        setValue: keys,
                        forPasteboardType: 'public.utf8-plain-text'
                    });
                } else {
                    plus.nativeUI.toast('导出失败');
                    return false;
                }

            } catch (err) {
                plus.nativeUI.toast(err.message);
            }

            plus.nativeUI.toast('全部区分代号已导出至剪贴板。');
        }
        //event.stopPropagation();
    }, false);

}());
