var fpSettings = null;

mui.plusReady(function() {
    'use strict';

    fpSettings = (function() {
        var NAME_KEYS = 'keys';
        var NAME_AUTOSAVEKEY = 'autoSaveKey';

        var NAME_SCRAMBLER = 'scrambler';
        var NAME_USESCRAMBLER = 'useScrambler';

        var NAME_PREFIX = 'prefix';
        var NAME_CUSTOMPREFIX = 'customPrefix';

        var NAME_SUFFIX = 'suffix';
        var NAME_CUSTOMSUFFIX = 'customSuffix';

        var NAME_HIDECODE = 'hideCode';

        var NAME_DIGIT = 'digit';
        var NAME_CUSTOMDIGIT = 'customDigit';

        var putHasAutoSaveKey = function (isTrue) {
            if (typeof(isTrue) === 'boolean') {
                if (isTrue) {
                    plus.storage.setItem(NAME_AUTOSAVEKEY, '1');
                } else {
                    plus.storage.setItem(NAME_AUTOSAVEKEY, '0');
                }
            } else {
                plus.storage.setItem(NAME_AUTOSAVEKEY, '0');
            }
        };

        var getHasAutoSaveKey = function () {
            var value = plus.storage.getItem(NAME_AUTOSAVEKEY);
            if (typeof(value) === 'string') {
                if (value === '1') {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        };

        var putKeys = function (value) {
            if (typeof(value) === 'object') {
                var l = value.length;
                while (l--) {
                    if (value[l].length > 0) {
                        value[l] = encodeURIComponent(value[l]);
                    } else {
                        value.splice(l, 1);
                    }
                }
                plus.storage.setItem(NAME_KEYS, value.sort().join(','));
            } else {
                plus.storage.setItem(NAME_KEYS, '');
            }
        };

        function uniq_fast(a) {
            var seen = {};
            var out = [];
            var len = a.length;
            var j = 0;

            for (var i = 0; i < len; i++) {
                var item = a[i];

                if (item && (item.length > 0) && (seen[item] !== 1)) {
                    seen[item] = 1;
                    out[j++] = item;
                }
            }
            return out;
        }

        var putKeysStr = function (value) {
            if (typeof(value) === 'string') {
                var keys = value.split(',');
                keys = uniq_fast(keys);
                plus.storage.setItem(NAME_KEYS, keys.sort().join(','));
            } else {
                plus.storage.setItem(NAME_KEYS, '');
            }
        };

        var getKeys = function () {
            var value = plus.storage.getItem(NAME_KEYS);
            if (typeof(value) === 'string') {
                var keys = value.split(',');

                if (keys) {
                    var l = keys.length;
                    while (l--) {
                      keys[l] = decodeURIComponent(keys[l]);
                    }
                    return keys;
                } else {
                    return [];
                }
            } else {
                return [];
            }
        };

        var getKeysStr = function () {
            var value = plus.storage.getItem(NAME_KEYS);
            if (typeof(value) === 'string') {
                return value;
            } else {
                return '';
            }
        };

        var getKeyCount = function () {
            var value = plus.storage.getItem(NAME_KEYS);
            if (typeof(value) === 'string') {
                var keys = value.split(',');

                if (keys) {
                    return keys.length;
                } else {
                    return 0;
                }
            } else {
                return 0;
            }
        };

        var putHasScrambler = function (isTrue) {
            if (typeof(isTrue) === 'boolean') {
                if (isTrue) {
                    plus.storage.setItem(NAME_SCRAMBLER, '1');
                } else {
                    plus.storage.setItem(NAME_SCRAMBLER, '0');
                }
            } else {
                plus.storage.setItem(NAME_SCRAMBLER, '0');
            }
        };

        var getHasScrambler = function () {
            var value = plus.storage.getItem(NAME_SCRAMBLER);
            if (typeof(value) === 'string') {
                if (value === '1') {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        };

        var putHasCustomPrefix = function (isTrue) {
            if (typeof(isTrue) === 'boolean') {
                if (isTrue) {
                    plus.storage.setItem(NAME_CUSTOMPREFIX, '1');
                } else {
                    plus.storage.setItem(NAME_CUSTOMPREFIX, '0');
                }
            } else {
                plus.storage.setItem(NAME_CUSTOMPREFIX, '0');
            }
        };

        var getHasCustomPrefix = function () {
            var value = plus.storage.getItem(NAME_CUSTOMPREFIX);
            if (typeof(value) === 'string') {
                if (value === '1') {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        };

        var putCustomPrefix = function (value) {
            if (typeof(value) === 'string') {
                plus.storage.setItem(NAME_PREFIX, value);
            } else {
                plus.storage.setItem(NAME_PREFIX, '');
            }
        };

        var getCustomPrefix = function () {
            var value = plus.storage.getItem(NAME_PREFIX);
            if (typeof(value) === 'string') {
                return value;
            } else {
                return '';
            }
        };

        var putHasCustomSuffix = function (isTrue) {
            if (typeof(isTrue) === 'boolean') {
                if (isTrue) {
                    plus.storage.setItem(NAME_CUSTOMSUFFIX, '1');
                } else {
                    plus.storage.setItem(NAME_CUSTOMSUFFIX, '0');
                }
            } else {
                plus.storage.setItem(NAME_CUSTOMSUFFIX, '0');
            }
        };

        var getHasCustomSuffix = function () {
            var value = plus.storage.getItem(NAME_CUSTOMSUFFIX);
            if (typeof(value) === 'string') {
                if (value === '1') {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        };

        var putCustomSuffix = function (value) {
            if (typeof(value) === 'string') {
                plus.storage.setItem(NAME_SUFFIX, value);
            } else {
                plus.storage.setItem(NAME_SUFFIX, '');
            }
        };

        var getCustomSuffix = function () {
            var value = plus.storage.getItem(NAME_SUFFIX);
            if (typeof(value) === 'string') {
                return value;
            } else {
                return '';
            }
        };

        var putHasHideCode = function (isTrue) {
            if (typeof(isTrue) === 'boolean') {
                if (isTrue) {
                    plus.storage.setItem(NAME_HIDECODE, '1');
                } else {
                    plus.storage.setItem(NAME_HIDECODE, '0');
                }
            } else {
                plus.storage.setItem(NAME_HIDECODE, '0');
            }
        };

        var getHasHideCode = function () {
            var value = plus.storage.getItem(NAME_HIDECODE);
            if (typeof(value) === 'string') {
                if (value === '1') {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        };

        var putHasCustomDigit = function (isTrue) {
            if (typeof(isTrue) === 'boolean') {
                if (isTrue) {
                    plus.storage.setItem(NAME_CUSTOMDIGIT, '1');
                } else {
                    plus.storage.setItem(NAME_CUSTOMDIGIT, '0');
                }
            } else {
                plus.storage.setItem(NAME_CUSTOMDIGIT, '0');
            }
        };

        var getHasCustomDigit = function () {
            var value = plus.storage.getItem(NAME_CUSTOMDIGIT);
            if (typeof(value) === 'string') {
                if (value === '1') {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        };

        var putCustomDigit = function (value) {
            if (typeof(value) === 'string') {
                plus.storage.setItem(NAME_DIGIT, value);
            } else {
                plus.storage.setItem(NAME_DIGIT, '16');
            }
        };

        var getCustomDigit = function () {
            var value = plus.storage.getItem(NAME_DIGIT);
            if (typeof(value) === 'string') {
                value = parseInt(value);
                if ((5 < value) && (value < 33)) {
                    return value;
                } else {
                    return 16;
                }
            } else {
                return 16;
            }
        };

        return {
            putHasAutoSaveKey: putHasAutoSaveKey,
            getHasAutoSaveKey: getHasAutoSaveKey,
            putKeys: putKeys,
            putKeysStr: putKeysStr,
            getKeys: getKeys,
            getKeysStr: getKeysStr,
            getKeyCount: getKeyCount,
            putHasScrambler: putHasScrambler,
            getHasScrambler: getHasScrambler,
            putHasCustomPrefix: putHasCustomPrefix,
            getHasCustomPrefix: getHasCustomPrefix,
            putCustomPrefix: putCustomPrefix,
            getCustomPrefix: getCustomPrefix,
            putHasCustomSuffix: putHasCustomSuffix,
            getHasCustomSuffix: getHasCustomSuffix,
            putCustomSuffix: putCustomSuffix,
            getCustomSuffix: getCustomSuffix,
            putHasHideCode: putHasHideCode,
            getHasHideCode: getHasHideCode,
            putHasCustomDigit: putHasCustomDigit,
            getHasCustomDigit: getHasCustomDigit,
            putCustomDigit: putCustomDigit,
            getCustomDigit: getCustomDigit
        };

    })();
});
