var fpUpdate = (function() {
    'use strict';

    function compareVersion(ov, nv) {
        if (!ov || !nv || ov === '' || nv === '') {
            return false;
        }
        var b = false,
            ova = ov.split('.', 4),
            nva = nv.split('.', 4);
        for (var i = 0; i < ova.length && i < nva.length; i++) {
            var so = ova[i],
                no = parseInt(so),
                sn = nva[i],
                nn = parseInt(sn);
            if (nn > no || sn.length > so.length) {
                return true;
            } else if (nn < no) {
                return false;
            }
        }
        if (nva.length > ova.length && 0 === nv.indexOf(ov)) {
            return true;
        }
    }

    var wgtVer = null;

    mui.plusReady(function() {
        plus.runtime.getProperty(plus.runtime.appid, function(inf) {
            wgtVer = inf.version;
            console.log('当前应用版本：' + wgtVer);
        });
    });

    var checkUrl = 'http://blog.xlsdg.org/fp/update.json';

    function checkUpdate() {
        if (!plus) {
            return;
        }

        plus.nativeUI.showWaiting('检测更新...');
        var xhr = new XMLHttpRequest();
        xhr.onreadystatechange = function() {
            switch (xhr.readyState) {
                case 4:
                    plus.nativeUI.closeWaiting();
                    if (xhr.status == 200) {
                        var srvRsp = xhr.responseText;
                        var srvData = '';
                        console.log('检测更新成功：' + srvRsp);

                        try {
                            srvData = JSON.parse(srvRsp);
                        } catch(e) {
                            plus.nativeUI.toast(e.message);
                            return;
                        }

                        var newAppId = '';
                        var newVer = '0.0.0';
                        var newNote = '';
                        var newUrl = '';
                        var wgtUrl = srvData.sau; // Smart App Updates

                        if (mui.os.ios) {
                            newAppId = srvData.ios.appid;
                            newVer = srvData.ios.version;
                            newNote = srvData.ios.note;
                            newUrl = srvData.ios.url;
                        } else if (mui.os.android) {
                            newAppId = srvData.android.appid;
                            newVer = srvData.android.version;
                            newNote = srvData.android.note;
                            newUrl = srvData.android.url;
                        } else {
                            return;
                        }

                        if (wgtVer && newVer && compareVersion(wgtVer, newVer)) {
                            plus.nativeUI.confirm('更新说明：\n' + newNote, function(event) {
                                if (0 === event.index) {
                                    downWgt(wgtUrl);
                                } else if (1 === event.index) {
                                    if (mui.os.android) {
                                        // 弹出系统选择按钮框
                                        var actionButtons = [{
                                            title: 'Google Play',
                                        }, {
                                            title: '360手机助手'
                                        }, {
                                            title: '应用宝'
                                        }, {
                                            title: '豌豆荚'
                                        }, {
                                            title: '百度手机助手'
                                        }, {
                                            title: '小米市场'
                                        }, {
                                            title: '魅族'
                                        }];

                                        var actionStyle = {
                                            title: '请选择安卓应用商店',
                                            cancel: '取消',
                                            buttons: actionButtons
                                        };

                                        plus.nativeUI.actionSheet(actionStyle, function(e) {
                                            if (e.index > 0) {
                                                //console.log(newUrl[e.index - 1]);
                                                plus.runtime.openURL(newUrl[e.index - 1]);
                                            }
                                        });
                                    } else {
                                        plus.runtime.openURL(newUrl);
                                    }
                                }
                            }, '发现新版本 v' + newVer, ['增量更新', '前往商店', '取消']);
                        } else {
                            plus.nativeUI.toast('无新版本可更新。');
                        }
                    } else {
                        console.log('检测更新失败！');
                        plus.nativeUI.toast('检测更新失败！');
                    }
                    break;
                default:
                    break;
            }
        };
        xhr.open('GET', checkUrl);
        xhr.send();
    }

    function downWgt(wgtUrl) {
        if (!plus) {
            return;
        }

        plus.nativeUI.showWaiting('正在下载更新文件...');
        plus.downloader.createDownload(wgtUrl, {
            filename: '_doc/update/'
        }, function(d, status) {
            if (status == 200) {
                console.log('下载wgt成功：' + d.filename);
                plus.nativeUI.toast('下载更新文件成功，准备安装...');
                installWgt(d.filename);
            } else {
                console.log('下载wgt失败！');
                plus.nativeUI.toast('下载更新文件失败！');
            }
            plus.nativeUI.closeWaiting();
        }).start();
    }

    function installWgt(path) {
        if (!plus) {
            return;
        }

        plus.nativeUI.showWaiting('安装更新文件...');
        plus.runtime.install(path, {}, function() {
            plus.nativeUI.closeWaiting();
            console.log('安装wgt文件成功！');
            plus.nativeUI.alert('更新完成，准备重启应用...', function() {
                plus.runtime.restart();
            }, '花密', '确定');
        }, function(e) {
            plus.nativeUI.closeWaiting();
            console.log('安装wgt文件失败[' + e.code + ']：' + e.message);
            plus.nativeUI.toast('安装更新文件失败[' + e.code + ']：' + e.message);
        });
    }

    return {
        checkUpdate: checkUpdate
    };

})();
